<?xml version="1.0" encoding="UTF-8"?>
<listing xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" xsi:noNamespaceSchemaLocation="urn:magento:module:Magento_Ui:etc/ui_configuration.xsd">

    <argument name="data" xsi:type="array">
        <item name="js_config" xsi:type="array">
            <item name="provider" xsi:type="string">filoblu_flow_log_listing.filoblu_flow_log_listing_data_source</item>
            <item name="deps" xsi:type="string">filoblu_flow_log_listing.filoblu_flow_log_listing_data_source</item>
        </item>
        <item name="spinner" xsi:type="string">spinner_columns</item>
    </argument>

    <listingToolbar name="listing_top">
        <argument name="data" xsi:type="array">
            <item name="config" xsi:type="array">
                <item name="sticky" xsi:type="boolean">false</item>
            </item>
        </argument>
        <bookmark name="bookmarks"/>
        <columnsControls name="columns_controls"/>
        <filterSearch name="fulltext">
        </filterSearch>
        <filters name="listing_filters" >
        </filters>
        <paging name="listing_paging"/>
        <exportButton name="export_button"/>
    </listingToolbar>

    <dataSource name="filoblu_flow_log_listing_data_source">
        <argument name="dataProvider" xsi:type="configurableObject">
            <argument name="class" xsi:type="string">Magento\Framework\View\Element\UiComponent\DataProvider\DataProvider</argument>
            <argument name="name" xsi:type="string">filoblu_flow_log_listing_data_source</argument>
            <argument name="primaryFieldName" xsi:type="string">id</argument>
            <argument name="requestFieldName" xsi:type="string">id</argument>
            <argument name="data" xsi:type="array">
                <item name="config" xsi:type="array">
                    <item name="update_url" xsi:type="url" path="mui/index/render"/>
                </item>
            </argument>
        </argument>
        <argument name="data" xsi:type="array">
            <item name="js_config" xsi:type="array">
                <item name="component" xsi:type="string">Magento_Ui/js/grid/provider</item>
            </item>
        </argument>
    </dataSource>

    <modal name="details" component="FiloBlu_Flow/js/modal">

       <!--<argument name="data" xsi:type="array">-->

            <!--<item name="config" xsi:type="array">-->
                <!--<item name="onCancel" xsi:type="string">actionCancel</item>-->
                <!--<item name="options" xsi:type="array">-->
                    <!--<item name="title" xsi:type="string" translate="true">Error detail</item>-->
                    <!--<item name="buttons" xsi:type="array">-->
                        <!--<item name="0" xsi:type="array">-->
                            <!--<item name="text" xsi:type="string">Done</item>-->
                            <!--<item name="class" xsi:type="string">action-primary</item>-->
                            <!--<item name="actions" xsi:type="array">-->
                                <!--<item name="0" xsi:type="string">actionDone</item>-->
                            <!--</item>-->
                        <!--</item>-->
                    <!--</item>-->
                <!--</item>-->
            <!--</item>-->
        <!--</argument>-->

        <insertForm name="errorDetail" >
            <settings>
                <formSubmitType>ajax</formSubmitType>
               <!-- <columnsProvider>ns = filoblu_flow_log_listing, index = spinner_columns</columnsProvider>-->
                <renderUrl path="mui/index/render_handle">
                    <param name="handle">flow_log_detail</param>
                </renderUrl>
                <updateUrl path="mui/index/render_handle">
                    <param name="handle">flow_log_detail</param>
                </updateUrl>
                <autoRender>false</autoRender>
                <loading>false</loading>
                <showSpinner>false</showSpinner>
                <realTimeLink>false</realTimeLink>
                <toolbarContainer>${ $.parentName }</toolbarContainer>
                <externalProvider>filoblu_flow_log_form.filoblu_flow_log_form_data_source</externalProvider>
                <ns>filoblu_flow_log_form</ns>
            </settings>
        </insertForm>
    </modal>

    <columns name="spinner_columns">

        <selectionsColumn name="ids">
            <argument name="data" xsi:type="array">
                <item name="config" xsi:type="array">
                    <item name="resizeEnabled" xsi:type="boolean">false</item>
                    <item name="resizeDefaultWidth" xsi:type="string">55</item>
                    <item name="indexField" xsi:type="string">id</item>
                </item>
            </argument>
        </selectionsColumn>

        <column name="id">
            <argument name="data" xsi:type="array">
                <item name="config" xsi:type="array">
                    <item name="filter" xsi:type="string">text</item>
                    <item name="component" xsi:type="string">Magento_Ui/js/grid/columns/column</item>
                    <item name="dataType" xsi:type="string">text</item>
                    <item name="label" xsi:type="string" translate="true">id</item>
                    <item name="sortOrder" xsi:type="number">10</item>
                </item>
            </argument>
        </column>

        <column name="meta_file">
            <argument name="data" xsi:type="array">
                <item name="config" xsi:type="array">
                    <item name="filter" xsi:type="string">text</item>
                    <item name="component" xsi:type="string">Magento_Ui/js/grid/columns/column</item>
                    <item name="dataType" xsi:type="string">text</item>
                    <item name="label" xsi:type="string" translate="true">Meta file</item>
                    <item name="sortOrder" xsi:type="number">20</item>
                </item>
            </argument>
        </column>

        <column name="message">
            <argument name="data" xsi:type="array">
                <item name="config" xsi:type="array">
                    <item name="filter" xsi:type="string">text</item>
                    <item name="component" xsi:type="string">Magento_Ui/js/grid/columns/column</item>
                    <item name="dataType" xsi:type="string">text</item>
                    <item name="label" xsi:type="string" translate="true">Message</item>
                    <item name="sortOrder" xsi:type="number">30</item>
                </item>
            </argument>
        </column>

        <column name="error_severity" class="FiloBlu\Flow\Ui\Component\Listing\Column\Log\Severity">
            <argument name="data" xsi:type="array">
                <item name="config" xsi:type="array">
                    <item name="options" xsi:type="array">
                        <item name="info" xsi:type="array">
                            <item name="value" xsi:type="string">info</item>
                            <item name="label" xsi:type="string" translate="true">Info</item>
                        </item>
                        <item name="debug" xsi:type="array">
                            <item name="value" xsi:type="string">debug</item>
                            <item name="label" xsi:type="string" translate="true">Debug</item>
                        </item>
                        <item name="error" xsi:type="array">
                            <item name="value" xsi:type="string">error</item>
                            <item name="label" xsi:type="string" translate="true">Error</item>
                        </item>
                        <item name="critical" xsi:type="array">
                            <item name="value" xsi:type="string">critical</item>
                            <item name="label" xsi:type="string" translate="true">Critical</item>
                        </item>
                        <item name="warning" xsi:type="array">
                            <item name="value" xsi:type="string">warning</item>
                            <item name="label" xsi:type="string" translate="true">Warning</item>
                        </item>
                    </item>
                    <item name="filter" xsi:type="string">select</item>
                    <item name="label" xsi:type="string" translate="true">Severity</item>
                    <item name="dataType" xsi:type="string">select</item>
                    <item name="bodyTmpl" xsi:type="string">ui/grid/cells/html</item>
                    <item name="sortOrder" xsi:type="number">40</item>
                    <item name="fieldAction" xsi:type="array">
                        <item name="provider" xsi:type="string">filoblu_flow_log_listing.filoblu_flow_log_listing.details</item>
                        <item name="target" xsi:type="string">openModal</item>
                        <item name="params" xsi:type="array">
                            <item name="0" xsi:type="string">filoblu_flow_log_listing.filoblu_flow_log_listing_data_source</item>
                            <item name="1" xsi:type="string">${ $.$data.rowIndex }</item>
                        </item>
                    </item>
                </item>
            </argument>
        </column>

        <column name="error_repeat_count">
            <argument name="data" xsi:type="array">
                <item name="config" xsi:type="array">
                    <item name="filter" xsi:type="string">textRange</item>
                    <item name="component" xsi:type="string">Magento_Ui/js/grid/columns/column</item>
                    <item name="dataType" xsi:type="string">text</item>
                    <item name="label" xsi:type="string" translate="true">Count</item>
                    <item name="sortOrder" xsi:type="number">50</item>
                </item>
            </argument>
        </column>

        <column name="meta_insert_time">
            <argument name="data" xsi:type="array">
                <item name="config" xsi:type="array">
                    <item name="filter" xsi:type="string">dateRange</item>
                    <item name="component" xsi:type="string">Magento_Ui/js/grid/columns/column</item>
                    <item name="dataType" xsi:type="string">text</item>
                    <item name="label" xsi:type="string" translate="true">Time</item>
                    <item name="sortOrder" xsi:type="number">60</item>
                </item>
            </argument>
        </column>

    </columns>
</listing>